import { J as Json, O as ObjectStorage, L as LogHandlerOptions, cP as LogMessage, a as LogHandler } from './uuid-b3f571c9.js';
export { dp as ArgumentsType, ci as AsyncMutex, V as BinInput, cZ as Channel, cY as ChannelMessageEvent, db as CryptoEncoder, at as Currency, ar as CurrencyInput, au as DAY_MS, aR as Day, aw as DayInput, aQ as DayInputLegacy, av as DayValue, aX as DecimalInput, aW as DecimalValue, d3 as DefaultListener, c8 as Disposable, c7 as Disposer, c6 as DisposerFunction, d4 as Emitter, d1 as EmitterAllHandler, d0 as EmitterHandler, d8 as Encoder, J as Json, da as JsonEncoder, d2 as ListenerSignature, c_ as LocalChannel, a as LogHandler, L as LogHandlerOptions, c as LogLevel, cM as LogLevelAlias, cN as LogLevelAliasKey, cO as LogLevelAliasType, cP as LogMessage, cL as Logger, cS as LoggerConsoleHandler, cR as LoggerContext, cQ as LoggerContextInterface, b as LoggerInterface, cX as LoggerMemoryHandler, dL as MemStorage, dK as MemStorageOptions, de as Message, dc as MessageAction, di as MessageDefinitions, dj as MessageHub, dd as MessageResult, dg as MessagesDefaultMethods, dh as MessagesMethods, df as MessagesOptions, ch as Mutex, dP as NestedArray, d9 as NoopEncoder, O as ObjectStorage, cr as Pool, cn as PoolTask, cp as PoolTaskEvents, cl as PoolTaskFn, co as PoolTaskIdConflictResolution, cm as PoolTaskState, b4 as Primitive, dm as PubSub, ds as RPCFn, dr as RPCOptions, dt as RPCReturn, an as RenderMessagesOptions, dq as ReturnType, bB as RoundingMode, cF as SerialQueue, bM as SortableItem, cE as TaskEvents, cD as TaskFn, a7 as Uint8ArrayToHexDump, a6 as Uint8ArrayToJson, Y as Uint8ArrayToString, cd as UseDefer, ca as UseDispose, c5 as XRX, W as _decodeUtf8Polyfill, _ as _encodeUtf8Polyfill, E as arrayAvg, F as arrayBatches, t as arrayEmptyInPlace, q as arrayFilterInPlace, l as arrayFlatten, m as arrayIntersection, w as arrayIsEqual, B as arrayMax, C as arrayMin, j as arrayMinus, A as arrayRandomElement, o as arrayRemoveElement, p as arraySetElement, y as arrayShuffle, z as arrayShuffleForce, x as arrayShuffleInPlace, u as arraySorted, v as arraySortedNumbers, D as arraySum, n as arraySymmetricDifference, s as arrayToggleInPlace, k as arrayUnion, i as arrayUnique, bq as avg, bo as between, b$ as cloneJsonObject, b_ as cloneObject, bx as cmp, bw as composeOrderby, G as createArray, c$ as createLocalChannelPair, cs as createPromise, dk as createPromiseProxy, h as csv, as as currency, aV as dateStringToDays, aU as day, az as dayDay, aP as dayDiff, aD as dayFromAny, aF as dayFromDate, aG as dayFromDateGMT, aK as dayFromParts, aL as dayFromString, aI as dayFromTimestamp, aC as dayFromToday, ay as dayMonth, aM as dayMonthStart, aO as dayOffset, aB as dayToDate, aE as dayToDateGMT, aA as dayToParts, aJ as dayToString, aH as dayToTimestamp, ax as dayYear, aN as dayYearStart, cH as debounce, aY as decimal, a$ as decimalCentsPart, aZ as decimalFromCents, a_ as decimalToCents, K as decodeBase16, N as decodeBase32, Q as decodeBase58, S as decodeBase62, U as decodeBase64, g as decrypt, b0 as deepEqual, b1 as deepMerge, e as deriveKeyPbkdf2, dG as detect, d as digest, bZ as empty, I as encodeBase16, M as encodeBase32, P as encodeBase58, R as encodeBase62, T as encodeBase64, bT as encodeQuery, f as encrypt, bO as endSortWeight, bV as ensureKey, bW as ensureKeyAsync, a4 as equalBinary, b2 as escapeHTML, bA as escapeRegExp, dx as fetchBasic, dy as fetchJson, dC as fetchOptionsBasicAuth, dA as fetchOptionsFormURLEncoded, dB as fetchOptionsJson, dz as fetchText, aq as fixBrokenUth8String, aS as forEachDay, c2 as forTimes, ao as formatMessages, dN as formatMilliseconds, a3 as fromBase64, ab as fromCamelCase, dF as getGlobal, cI as getGlobalContext, d5 as getGlobalEmitter, cK as getGlobalLogger, cT as getNamespaceFilterString, dE as getNavigator, bj as getSecureRandom, bk as getSecureRandomIfPossible, dM as getTimestamp, dD as getWindow, dv as httpMethod, cu as immediate, b7 as isArray, bd as isBoolean, dH as isBrowser, bD as isEven, bC as isHalf, bb as isInteger, cJ as isLocalHost, be as isNullOrUndefined, ba as isNumber, b5 as isObject, bs as isPrime, br as isPrimeRX, b6 as isPrimitive, cB as isPromise, b8 as isRecord, bc as isSafeInteger, b9 as isString, cy as isTimeout, bf as isUint8Array, $ as joinToUint8Array, bi as jsonStringify, bh as jsonStringifySafe, bg as jsonStringifySorted, a5 as jsonToUint8Array, bY as last, d7 as lazyListener, bR as linkifyPlainText, c0 as memoize, c1 as memoizeAsync, d6 as messages, bP as moveSortWeight, bu as objectMap, dw as parseBasicAuth, dO as parseDate, cV as parseLogLevel, bv as parseOrderby, bU as parseQuery, dI as platform, cC as promisify, dZ as qid, bl as randomBoolean, bn as randomFloat, bm as randomInt, r as randomUint8Array, c4 as regExpEscape, c3 as regExpString, ap as renderMessages, bF as roundDown, bI as roundHalfAwayFromZero, bJ as roundHalfDown, bK as roundHalfEven, bH as roundHalfOdd, bL as roundHalfTowardsZero, bG as roundHalfUp, bE as roundUp, bt as seededRandom, bX as size, ct as sleep, bQ as sortedItems, by as sortedOrderby, bN as startSortWeight, ac as stringToBoolean, ae as stringToFloat, ad as stringToInteger, X as stringToUInt8Array, e0 as suid, d$ as suidBytes, e2 as suidBytesDate, e1 as suidDate, bp as sum, cG as throttle, cw as timeout, cv as timeoutReached, cx as timoutError, a1 as toBase64, a2 as toBase64Url, am as toBool, a8 as toCamelCase, a9 as toCapitalize, aa as toCapitalizeWords, aj as toFloat, a0 as toHex, bS as toHumanReadableUrl, ak as toInt, al as toString, Z as toUint8Array, bz as toValidFilename, aT as today, cz as tryTimeout, dY as uname, b3 as unescapeHTML, ck as useAsyncMutex, H as useBase, cc as useDefer, c9 as useDispose, cb as useDisposer, cg as useEventListener, dJ as useExitHandler, cf as useInterval, cW as useLevelFilter, dl as useMessageHub, cj as useMutex, cU as useNamespaceFilter, cq as usePool, dn as usePubSub, du as useRPC, ce as useTimeout, dS as uuid, dX as uuid32Decode, dW as uuid32Encode, dR as uuid32bit, dV as uuidB32, dQ as uuidBytes, dU as uuidDecode, dT as uuidEncode, d_ as uuidv4, af as valueToBoolean, ah as valueToFloat, ag as valueToInteger, ai as valueToString, cA as waitOn } from './uuid-b3f571c9.js';

interface ParseConfig {
    args?: string[];
    alias?: Record<string, string[]>;
    normalize?: (value: string) => string;
    booleanArgs?: string | string[];
    listArgs?: string | string[];
    numberArgs?: string | string[];
}
declare function parseArgs(config?: ParseConfig): Record<string, any>;

/** Copy string to clipboard */
declare function pbcopy(data: string): Promise<unknown>;

declare type csvOptions = {
    /** @deprecated will probably be replaced by logLevel */
    debug?: boolean;
    path?: string;
    filename?: string;
    encoding?: BufferEncoding;
    prefix?: string;
    env?: Record<string, string>;
};
/**
 * Return a path relative to the current working directory
 */
declare function stringToPath(value?: string, defaultValue?: string): string;
declare function valueToPath(value?: any, defaultValue?: string): string;
declare const toPath: typeof valueToPath;
declare function getEnvVariableRelaxed(name: string, env?: NodeJS.ProcessEnv): string | undefined;
/** Populates process.env from .env file. */
declare function setupEnv(options?: csvOptions): {
    parsed: Record<string, string>;
    error?: undefined;
} | {
    error: unknown;
    parsed?: undefined;
};

interface FileStorageOptions {
    pretty?: boolean;
    path?: string;
    extension?: string;
    objectFromString?: (data: string) => any;
    objectToString?: (data: any) => string;
    keyToFilename?: (key: string) => string;
}
declare class FileStorage<T = Json> implements ObjectStorage<T> {
    private store;
    private dirname;
    private fileKeys?;
    private pretty;
    private extension;
    private extensionLength;
    private objectFromString;
    private objectToString;
    private keyToFilename;
    constructor(opt?: FileStorageOptions);
    setItem(key: string, value: T): void;
    getPath(key: string): string;
    getBuffer(key: string): Buffer;
    getItem(key: string): T | undefined;
    removeItem(key: string): void;
    clear(): void;
    allKeys(): string[];
}

declare function toHumanReadableFilePath(path: string): string;
declare function exists(path: string): Promise<boolean>;
declare function ensureFolder(...parts: string[]): Promise<string>;
declare function removeFolder(...parts: string[]): Promise<string>;
declare function readText(...parts: string[]): Promise<string | undefined>;
declare function writeText(path: string, content: string): Promise<void>;

declare function LoggerFileHandler(path: string, opt?: LogHandlerOptions): (msg: LogMessage) => void;

declare function colorString(text: string, colorCode: number): string;
declare function colorStringList(list: Array<any>, style: string, bold?: boolean): any[];
declare const loggerStackTraceDebug = "loggerStackTraceDebug-7d38e5a9214b58d29734374cdb9521fd964d7485";
declare function LoggerNodeHandler(opt?: LogHandlerOptions): LogHandler;

declare function getStackLlocationList(stack: string): any[];
/**
 * Get the source code location of the caller
 * https://stackoverflow.com/a/47296370/140927
 *
 * @param level Number of levels to go down the stack trace
 * @param stripCwd Strip the current working directory, only reasonable for Node.js environment
 * @returns
 */
declare function getSourceLocation(level?: number, stripCwd?: boolean): string;
declare function getStack(): string;
declare function getSourceLocationByPrecedingPattern(patterns: string[], stripCwd?: boolean): string;

export { FileStorage, FileStorageOptions, LoggerFileHandler, LoggerNodeHandler, colorString, colorStringList, ensureFolder, exists, getEnvVariableRelaxed, getSourceLocation, getSourceLocationByPrecedingPattern, getStack, getStackLlocationList, loggerStackTraceDebug, parseArgs, pbcopy, readText, removeFolder, setupEnv, stringToPath, toHumanReadableFilePath, toPath, valueToPath, writeText };
